Package org.apache.jasper.runtime

# Class BodyContentImpl

java.lang.Object
java.io.Writer
javax.servlet.jsp.JspWriter
javax.servlet.jsp.tagext.BodyContent
org.apache.jasper.runtime.BodyContentImpl

All Implemented Interfaces:
  `Closeable`, `Flushable`, `Appendable`, `AutoCloseable`

public class BodyContentImpl extends BodyContent
Write text to a character-output stream, buffering characters so as to provide for the efficient writing of single characters, arrays, and strings. Provide support for discarding for the output that has been buffered.

Author:
  Rajiv Mordani, Jan Luehe

- ## Field Summary

  ### Fields inherited from class javax.servlet.jsp.JspWriter

  `autoFlush, bufferSize, DEFAULT_BUFFER, NO_BUFFER, UNBOUNDED_BUFFER`

  ### Fields inherited from class java.io.Writer

  `lock`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BodyContentImpl(JspWriter enclosingWriter)`
  Constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Clear the contents of the buffer.
  `void`
  `clearBuffer()`
  Clears the current contents of the buffer.
  `void`
  `close()`
  Close the stream, flushing it first.
  `int`
  `getBufferSize()`
  This method returns the size of the buffer used by the JspWriter.
  `Reader`
  `getReader()`
  Return the value of this BodyJspWriter as a Reader.
  `int`
  `getRemaining()`
  This method returns the number of unused bytes in the buffer.
  `String`
  `getString()`
  Return the value of the BodyJspWriter as a String.
  `void`
  `newLine()`
  Write a line separator.
  `void`
  `print(boolean b)`
  Print a boolean value.
  `void`
  `print(char c)`
  Print a character.
  `void`
  `print(char[] s)`
  Print an array of characters.
  `void`
  `print(double d)`
  Print a double-precision floating-point number.
  `void`
  `print(float f)`
  Print a floating-point number.
  `void`
  `print(int i)`
  Print an integer.
  `void`
  `print(long l)`
  Print a long integer.
  `void`
  `print(Object obj)`
  Print an object.
  `void`
  `print(String s)`
  Print a string.
  `void`
  `println()`
  Terminate the current line by writing the line separator string.
  `void`
  `println(boolean x)`
  Print a boolean value and then terminate the line.
  `void`
  `println(char x)`
  Print a character and then terminate the line.
  `void`
  `println(char[] x)`
  Print an array of characters and then terminate the line.
  `void`
  `println(double x)`
  Print a double-precision floating-point number and then terminate the line.
  `void`
  `println(float x)`
  Print a floating-point number and then terminate the line.
  `void`
  `println(int x)`
  Print an integer and then terminate the line.
  `void`
  `println(long x)`
  Print a long integer and then terminate the line.
  `void`
  `println(Object x)`
  Print an Object and then terminate the line.
  `void`
  `println(String x)`
  Print a String and then terminate the line.
  `protected void`
  `recycle()`
  This method shall "reset" the internal state of a BodyContentImpl, releasing all internal references, and preparing it for potential reuse by a later invocation of `PageContextImpl.pushBody(Writer)`.
  `void`
  `write(char[] buf)`
  Write an array of characters.
  `void`
  `write(char[] cbuf, int off, int len)`
  Write a portion of an array of characters.
  `void`
  `write(int c)`
  Write a single character.
  `void`
  `write(String s)`
  Write a string.
  `void`
  `write(String s, int off, int len)`
  Write a portion of a String.
  `void`
  `writeOut(Writer out)`
  Write the contents of this BodyJspWriter into a Writer.

  ### Methods inherited from class javax.servlet.jsp.tagext.BodyContent

  `clearBody, flush, getEnclosingWriter`

  ### Methods inherited from class javax.servlet.jsp.JspWriter

  `isAutoFlush`

  ### Methods inherited from class java.io.Writer

  `append, append, append, nullWriter`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BodyContentImpl

    public BodyContentImpl(JspWriter enclosingWriter)
    Constructor.
    Parameters:
      `enclosingWriter` - The wrapped writer

- ## Method Details

  - ### write

    public void write(int c) throws IOException
    Write a single character.
    Overrides:
      `write` in class `Writer`
    Parameters:
      `c` - The char to write
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### write

    public void write(char[] cbuf, int off, int len) throws IOException
    Write a portion of an array of characters.

    Ordinarily this method stores characters from the given array into this stream's buffer, flushing the buffer to the underlying stream as needed. If the requested length is at least as large as the buffer, however, then this method will flush the buffer and write the characters directly to the underlying stream. Thus redundant `DiscardableBufferedWriter`s will not copy data unnecessarily.

    Specified by:
      `write` in class `Writer`
    Parameters:
      `cbuf` - A character array
      `off` - Offset from which to start reading characters
      `len` - Number of characters to write
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### write

    public void write(char[] buf) throws IOException
    Write an array of characters. This method cannot be inherited from the Writer class because it must suppress I/O exceptions.
    Overrides:
      `write` in class `Writer`
    Parameters:
      `buf` - Content to write
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### write

    public void write(String s, int off, int len) throws IOException
    Write a portion of a String.
    Overrides:
      `write` in class `Writer`
    Parameters:
      `s` - String to be written
      `off` - Offset from which to start reading characters
      `len` - Number of characters to be written
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### write

    public void write(String s) throws IOException
    Write a string. This method cannot be inherited from the Writer class because it must suppress I/O exceptions.
    Overrides:
      `write` in class `Writer`
    Parameters:
      `s` - String to be written
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### newLine

    public void newLine() throws IOException
    Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.
    Specified by:
      `newLine` in class `JspWriter`
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### print

    public void print(boolean b) throws IOException
    Print a boolean value. The string produced by ``String.valueOf(boolean)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `b` - The `boolean` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### print

    public void print(char c) throws IOException
    Print a character. The character is translated into one or more bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `c` - The `char` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### print

    public void print(int i) throws IOException
    Print an integer. The string produced by ``String.valueOf(int)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `i` - The `int` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer
    See Also:
      - `Integer.toString(int)`

  - ### print

    public void print(long l) throws IOException
    Print a long integer. The string produced by ``String.valueOf(long)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `l` - The `long` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer
    See Also:
      - `Long.toString(long)`

  - ### print

    public void print(float f) throws IOException
    Print a floating-point number. The string produced by ``String.valueOf(float)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `f` - The `float` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer
    See Also:
      - `Float.toString(float)`

  - ### print

    public void print(double d) throws IOException
    Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `d` - The `double` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer
    See Also:
      - `Double.toString(double)`

  - ### print

    public void print(char[] s) throws IOException
    Print an array of characters. The characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `s` - The array of chars to be printed
    Throws:
      `NullPointerException` - If `s` is `null`
      `IOException` - Error writing to wrapped writer

  - ### print

    public void print(String s) throws IOException
    Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are converted into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `s` - The `String` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### print

    public void print(Object obj) throws IOException
    Print an object. The string produced by the ``String.valueOf(Object)`` method is translated into bytes according to the platform's default character encoding, and these bytes are written in exactly the manner of the ``write(int)`` method.
    Specified by:
      `print` in class `JspWriter`
    Parameters:
      `obj` - The `Object` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer
    See Also:
      - `Object.toString()`

  - ### println

    public void println() throws IOException
    Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`).
    Specified by:
      `println` in class `JspWriter`
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(boolean x) throws IOException
    Print a boolean value and then terminate the line. This method behaves as though it invokes ``print(boolean)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `boolean` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(char x) throws IOException
    Print a character and then terminate the line. This method behaves as though it invokes ``print(char)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `char` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(int x) throws IOException
    Print an integer and then terminate the line. This method behaves as though it invokes ``print(int)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `int` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(long x) throws IOException
    Print a long integer and then terminate the line. This method behaves as though it invokes ``print(long)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `long` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(float x) throws IOException
    Print a floating-point number and then terminate the line. This method behaves as though it invokes ``print(float)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `float` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(double x) throws IOException
    Print a double-precision floating-point number and then terminate the line. This method behaves as though it invokes ``print(double)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `double` to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(char[] x) throws IOException
    Print an array of characters and then terminate the line. This method behaves as though it invokes ``print(char[])`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The `char` array to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(String x) throws IOException
    Print a String and then terminate the line. This method behaves as though it invokes ``print(String)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The string to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### println

    public void println(Object x) throws IOException
    Print an Object and then terminate the line. This method behaves as though it invokes ``print(Object)`` and then ``println()``.
    Specified by:
      `println` in class `JspWriter`
    Parameters:
      `x` - The object to be printed
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### clear

    public void clear() throws IOException
    Clear the contents of the buffer. If the buffer has been already been flushed then the clear operation shall throw an IOException to signal the fact that some data has already been irrevocably written to the client response stream.
    Specified by:
      `clear` in class `JspWriter`
    Throws:
      `IOException` - If there is no wrapped writer

  - ### clearBuffer

    public void clearBuffer() throws IOException
    Clears the current contents of the buffer. Unlike clear(), this method will not throw an IOException if the buffer has already been flushed. It merely clears the current content of the buffer and returns.
    Specified by:
      `clearBuffer` in class `JspWriter`
    Throws:
      `IOException` - Should not happen

  - ### close

    public void close() throws IOException
    Close the stream, flushing it first. Once a stream has been closed, further write() or flush() invocations will cause an IOException to be thrown. Closing a previously-closed stream, however, has no effect.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Specified by:
      `close` in class `JspWriter`
    Throws:
      `IOException` - Error writing to wrapped writer

  - ### getBufferSize

    public int getBufferSize()
    This method returns the size of the buffer used by the JspWriter.
    Overrides:
      `getBufferSize` in class `JspWriter`
    Returns:
      the size of the buffer in bytes, or 0 is unbuffered.

  - ### getRemaining

    public int getRemaining()
    Description copied from class: `javax.servlet.jsp.JspWriter`
    This method returns the number of unused bytes in the buffer.
    Specified by:
      `getRemaining` in class `JspWriter`
    Returns:
      the number of bytes unused in the buffer

  - ### getReader

    public Reader getReader()
    Return the value of this BodyJspWriter as a Reader. Note: this is after evaluation!! There are no scriptlets, etc in this stream.
    Specified by:
      `getReader` in class `BodyContent`
    Returns:
      the value of this BodyJspWriter as a Reader

  - ### getString

    public String getString()
    Return the value of the BodyJspWriter as a String. Note: this is after evaluation!! There are no scriptlets, etc in this stream.
    Specified by:
      `getString` in class `BodyContent`
    Returns:
      the value of the BodyJspWriter as a String

  - ### writeOut

    public void writeOut(Writer out) throws IOException
    Write the contents of this BodyJspWriter into a Writer. Subclasses are likely to do interesting things with the implementation so some things are extra efficient.
    Specified by:
      `writeOut` in class `BodyContent`
    Parameters:
      `out` - The writer into which to place the contents of this body evaluation
    Throws:
      `IOException` - Error writing to writer

  - ### recycle

    protected void recycle()
    This method shall "reset" the internal state of a BodyContentImpl, releasing all internal references, and preparing it for potential reuse by a later invocation of `PageContextImpl.pushBody(Writer)`.

    Note, that BodyContentImpl instances are usually owned by a PageContextImpl instance, and PageContextImpl instances are recycled and reused.

    See Also:
      - `PageContextImpl.release()`